<script lang="ts">
import Vue from 'vue';
import { HorizontalScrollBar } from '../common/index.vue';

export default Vue.extend({
  components: { HorizontalScrollBar },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  data() {
    return {
      progress: 0,
    };
  },
  mounted() {
    const { cards } = this.$refs;
    cards.$el.addEventListener(
      'scroll',

      function (e) {
        const { clientWidth } = e.target;
        const { scrollLeft } = e.target;
        const { scrollWidth } = e.target;

        const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
        const scrollPercentRounded = Math.round(scrollPercent * 100);
        this.progress = scrollPercentRounded;
      }.bind(this),
    );
  },
});
</script>

<template>
  <section class="showcase-wrapper">
    <SlpContainer>
      <div v-if="data.title" class="showcase__gradient-header" />
      <SlpTypography v-if="data.authorTitle" tag="h2" variant="heading2-bold">
        {{ data.title }}
      </SlpTypography>
      <SlpRow ref="cards" class="slp-mb-md-94 slp-mb-64 cards">
        <SlpColumn v-for="item in data.items" :key="item.title" :cols="4">
          <!-- WITH LINK -->
          <a
            v-if="item.link"
            class="showcase-card"
            :href="item.link.href"
            :data-ga-name="item.link.data_ga_name"
            :data-ga-location="item.link.data_ga_location"
          >
            <div class="content">
              <SlpIcon
                v-if="item.icon"
                class="slp-mb-24"
                :name="item.icon.name"
                :variant="item.icon.variant"
                :alt="item.icon.alt"
                size="md"
                slp-color="primary-200"
              />
              <div>
                <SlpTypography
                  tag="h3"
                  variant="heading5-bold"
                  :class="item.link.text && 'showcase-card__link'"
                >
                  {{ item.title }}
                </SlpTypography>
                <SlpTypography tag="p" variant="body1">
                  {{ item.text }}
                </SlpTypography>
              </div>

              <span v-if="item.link.text"
                >{{ item.link.text }}
                <SlpIcon
                  class="slp-ml-8"
                  name="chevron-lg-right"
                  variant="product"
                  alt="Chevron Right Icon"
              /></span>
              <SlpIcon
                v-else
                name="arrow-right"
                variant="product"
                size="sm"
                class="arrow-icon"
              />
            </div>
          </a>
          <!-- WITHOUT LINK -->
          <div v-else class="showcase-card">
            <div>
              <SlpIcon
                v-if="item.icon"
                :name="item.icon.name"
                :variant="item.icon.variant"
                :alt="item.icon.alt"
                size="md"
                class="slp-mb-24"
              />
              <SlpTypography tag="h3" variant="heading5-bold">
                {{ item.title }}
              </SlpTypography>
              <SlpTypography tag="p" variant="body1">
                {{ item.text }}
              </SlpTypography>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <HorizontalScrollBar :value="progress" class="horizontal-scroll" />
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.content {
  height: 100%;
  display: flex;
  flex-direction: column;
}
.arrow-icon {
  margin-top: auto;
  color: black;
}
.showcase-wrapper {
  background: $color-surface-800;
  padding: $spacing-96 0;

  h2 {
    margin-bottom: $spacing-64;
  }

  .slp-col-md-4 {
    padding-right: $spacing-16;
    padding-bottom: $spacing-16;
  }
}

.showcase__gradient-header {
  background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
  height: 4px;
  width: 95px;
  border-radius: 10px;
  margin-bottom: $spacing-16;
}

.icon {
  margin-bottom: $spacing-16;
}

.horizontal-scroll {
  display: none;
}

.cards {
  position: relative;
}

a.showcase-card:hover {
  border-radius: 0 0 100px 0;
}

.showcase-card {
  display: block;
  background: $color-surface-50;
  height: 300px;
  width: 100%;
  padding: $spacing-32 $spacing-24;
  transition: all 0.3s ease-in-out;
  position: relative;

  p,
  a,
  span {
    color: $color-text-300;
  }

  h3 {
    display: block;
    margin-bottom: $spacing-16;
    max-width: 318px;
    color: $color-text-300;
  }

  span {
    display: flex;
    flex: 1 0 auto;
    align-items: center;
    font-weight: $font-weight-bold;
    font-size: $text-body-2-bold;
    margin-top: $spacing-16;

    svg {
      margin-left: 10px;
    }
  }

  &__link {
    color: $color-text-300;
  }
}

@media (max-width: 767px) {
  .showcase-wrapper .slp-col-md-4 {
    padding-right: 0;
  }

  .cards {
    flex-wrap: nowrap;
    overflow-x: scroll;
    margin-bottom: 0;

    scrollbar-width: none; // hides scrollbar on Firefox
    -ms-overflow-style: none; // hides scrollbar on IE 10+

    &::-webkit-scrollbar {
      // hides scrollbar on browsers that use that use Webkit (Chrome, Safari, Opera, etc)
      width: 0;
      height: 0;
      display: none;
    }
  }

  .showcase-card {
    height: 100%;
    width: 270px;
    margin-right: $spacing-16;
  }

  .horizontal-scroll {
    margin-top: $spacing-32;
    display: block;
  }
}
</style>
